Subject: Re: RFC: Separate commit identification from Merkle hashing

From: Jonathan Nieder <[email-masked]>
Date: Thu, 23 May 2019 13:54:57 -0700

Eric S. Raymond wrote:
> Jakub Narebski <[email-masked]>:

>> Currently Git makes use of the fact that SHA-1 and SHA-256 identifiers
>> are of different lengths to distinguish them (see section "Meaning of
>> signatures") in Documentation/technical/hash-function-transition.txt
>
> That's the obvious hack.  As a future-proofing issue, though, I think
> it would be unwise to count on all future hashes being of distinguishable
> lengths.

We're not counting on that.  As discussed in that section, future
hashes can change the format.

[...]
>> All right.  Looks sensible on first glance.
>
> I am very relieved to hear that. My view of git is outside-in; I was quite
> worried I might have missed some crucial issue.

Honestly, I do think you have missed some fundamental issues.
https://public-inbox.org/git/[email-masked]/
discusses this further.

Regards,
Jonathan